SystemOrganization addCategory: #SystemEditorBrowser!

MetaclassEditor subclass: #MetaclassEditorUIModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!MetaclassEditorUIModel class methodsFor: 'UI closure' stamp: 'mtf 1/25/2008 11:21'!
new
	| instance |
	instance := self basicNew.
	instance
		superclass: ClassEditorUIModel
		methodDictionary: MethodDictionary new
		format: ClassEditorUIModel format.
	^ instance! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:24'!
compile: source classified: category withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := MethodEditorUIModel
			source: source
			classified: category
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	self methods add: cm.! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:40'!
edInitializeForNewClass
	superEditor := self system edEditorFor: Object class.
	instVarNames := Array new.
	methods := MethodDictionaryEditorUIModel for: self! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:41'!
methodDictionary
	| methodEditor |
	(methods isNil and: [self edRequiresRecompile not]) ifTrue: [^ self subject methodDictionary].
	methodEditor := methods ifNil: [MethodDictionaryEditorUIModel for: self].
	^ methodEditor buildFor: self! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:41'!
methods
	^ methods ifNil: [methods := MethodDictionaryEditorUIModel for: self]! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/18/2008 14:46'!
organization
	^ organization ifNil: [organization := ClassOrganizationUIModel for: self]! !

!MetaclassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:42'!
removeSelector: aSymbol 
	methods ifNil: [methods := MethodDictionaryEditorUIModel for: self].
	methods remove: aSymbol.! !

Browser subclass: #SystemEditorBrowser
	instanceVariableNames: 'editor showChangesOnly showingFull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!SystemEditorBrowser commentStamp: '<historical>' prior: 0!
An evil but very useful hack that combines Browser and SystemEditor in a way neither was meant to be used. Displays all the changes that you have made to a SystemEditor in a plain browser. It (at least used to) work when used on a regular SystemEditor, but when used on a SystemEditorUIModel, you can filter the view to only show the changed elements, view removed classes/methods, and see it all in COLOR!!!!!! Ooh, pretty!

!SystemEditorBrowser methodsFor: 'as yet unclassified' stamp: 'mtf 1/19/2008 20:59'!
contentsSymbolQuints
	"Answer a list of quintuplets representing information on the alternative views available in the code pane"

	^ self editor 
		ifNil: [super contentsSymbolQuints]
		ifNotNil: [self sourceAndDiffsQuintsOnly]! !

!SystemEditorBrowser methodsFor: 'accessing' stamp: 'mtf 11/2/2007 21:26'!
editor
	^ editor! !

!SystemEditorBrowser methodsFor: 'accessing' stamp: 'mtf 11/2/2007 21:26'!
editor: anEditor 
	"Changes the system editor being shown, Attempts to preserve as much
	of the selection as possible"
	editor := anEditor.
	self systemOrganizer: (anEditor
		ifNil: [SystemOrganization]
		ifNotNil: [anEditor organization]).
	self systemCategoryListIndex: 0. "Deselect all classes"! !

!SystemEditorBrowser methodsFor: 'view limiting' stamp: 'mtf 1/20/2008 18:19'!
isShowingChangesOnly
	^ self isShowingFullSystem not! !

!SystemEditorBrowser methodsFor: 'view limiting' stamp: 'mtf 1/20/2008 18:18'!
isShowingFullSystem
	editor ifNil: [^ true].
	^ editor isShowingFullSystem! !

!SystemEditorBrowser methodsFor: 'accessing' stamp: 'mtf 11/2/2007 21:26'!
selectedEnvironment
	"Overridden to support using a SystemEditor as the environment"
	
	self editor ifNotNil: [^ self editor].
	^ super selectedEnvironment! !

!SystemEditorBrowser methodsFor: 'message list' stamp: 'mtf 11/2/2007 21:26'!
selectedMessage
	"Answer a copy of the source code for the selected message."

	| class selector method |
	editor ifNil: [^ super selectedMessage].
	contents == nil ifFalse: [^ contents copy].

	class := self selectedClassOrMetaClass.
	selector := self selectedMessageName.
	method :=  class compiledMethodAt: selector ifAbsent: [^ ''].	"method deleted while in another project"
	currentCompiledMethod := method.

	self showingDocumentation
		ifFalse: [contents := self sourceStringPrettifiedAndDiffed]
		ifTrue: [contents := self commentContents].
	^ contents := contents copy asText makeSelectorBoldIn: class! !

!SystemEditorBrowser methodsFor: 'view limiting' stamp: 'mtf 1/20/2008 18:21'!
showChangesOnly
	self okToChange ifFalse: [^ self].
	self isShowingChangesOnly ifTrue: [^ self].
	editor ifNil: [^ self].

	self editor showChangesOnly.! !

!SystemEditorBrowser methodsFor: 'accessing' stamp: 'mtf 11/2/2007 21:26'!
showChangesOnly: aBool
	showChangesOnly := true! !

!SystemEditorBrowser methodsFor: 'view limiting' stamp: 'mtf 1/20/2008 18:20'!
showFullSystem
	self okToChange ifFalse: [^ self].
	self isShowingFullSystem ifTrue: [^ self].
	editor ifNil: [^ self].

	self editor showFullSystem.! !

SystemEditor subclass: #SystemEditorUIModel
	instanceVariableNames: 'showingFullSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!SystemEditorUIModel commentStamp: 'mtf 1/24/2008 22:45' prior: 0!
My instances look and act like SystemEditors (and therefore like a normal SystemDictionary or Class), but I do a few tricks to show changes nicely:

- When you remove a class, I don't actually remove it, but move it to a new key so you can still see it in the browser. MethodDictionaryEditorUIModel behaves similarly
- The methods under "view limiting" tweak the SystemOrganization and ClassOrganization editors so that the browser (and therefore you), only see the parts of the system you changed. This is enabled by default, since reviewing your changes is presumably the whole reason you are looking at the editor in the first place.
- Class and Method editors have several flags (added, removed, and conflict), that effect what colors the browser displays. Added and Removed get set automatically by just using the SystemEditor normally; conflict has to be set by whomever is using SystemEditor as a backend!

!SystemEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:16'!
at: aSymbol ifAbsent: aBlock
	(removals includes: aSymbol) ifTrue: [^ aBlock value].
	editors at: aSymbol ifPresent: [:editor | ^ editor].
	subject at: aSymbol ifPresent: 
		[:class | 
		^ class isBehavior 
				ifTrue: [(ClassEditorUIModel on: class for: self) edRegisterEditor ]
				ifFalse: [class]].
	^ aBlock value! !

!SystemEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/24/2008 22:29'!
commit
	self error: 'Don''t commit a viewer'! !

!SystemEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:17'!
edEditorFor: aClass
	| name editor |
	aClass edIsEditor ifTrue: [^ aClass].
	name := aClass theNonMetaClass name.
	editor := ClassEditorUIModel named: name for: self.
	^ aClass isMeta ifFalse: [editor] ifTrue: [editor class].! !

!SystemEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 11:38'!
edRegisterEditor: aClassEditor 
	(self includesKey: aClassEditor name) ifFalse: [aClassEditor flagNew].
	^ super edRegisterEditor: aClassEditor! !

!SystemEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 11:52'!
edRemoveClassNamed: aSymbol
	| editor |
	editor := self at: aSymbol ifAbsent: [^ nil].
	editors at: (self uniqueNameLike: aSymbol) put: editor.
	editors removeKey: aSymbol.
	editor flagRemoval.
	^ editor! !

!SystemEditorUIModel methodsFor: 'viewLimiting' stamp: 'mtf 1/22/2008 22:00'!
isShowingFullSystem
	^ showingFullSystem ifNil: [false]! !

!SystemEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/18/2008 14:43'!
organization
	^ organization ifNil: [organization := SystemOrganizationUIModel for: self]! !

!SystemEditorUIModel methodsFor: 'viewLimiting' stamp: 'mtf 1/21/2008 09:38'!
showChangesOnly
	showingFullSystem := false! !

!SystemEditorUIModel methodsFor: 'viewLimiting' stamp: 'mtf 1/21/2008 09:38'!
showFullSystem
	showingFullSystem := true! !

!SystemEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/23/2008 09:41'!
uniqueNameLike: aSymbol
	"Answers a new, unique key under which to store a removed class editor. the key is an invalid class name, so It shouldn't caus spurious conflicts by still existing (it contains a period)"

	| try |
	self at: aSymbol ifAbsent: [^ aSymbol].

	1 to: 999999 do:
		[:i | try := (aSymbol , '.', i printString) asSymbol.
		self at: try ifAbsent: [^ try]]! !

OrganizationEditor subclass: #ClassOrganizationUIModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!ClassOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/24/2008 22:20'!
categories

	self isShowingFullSystem ifTrue: [^ super categories].
	^ (self subjectCategories intersection: self changedCategories), addedCategories! !

!ClassOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/21/2008 09:44'!
isShowingFullSystem
	^ classEditor system isShowingFullSystem! !

!ClassOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/24/2008 22:20'!
listAtCategoryNamed: catName

	| oldList newList category |
	category := catName asSymbol.
	(self categories includes: category) ifFalse: [^ #()].
	newList := (self changesInCategory: category) ifNil: [#()].
	oldList := self isShowingFullSystem ifFalse: [#()]
		ifTrue: [(self subjectListAtCategoryNamed: category) ifNil: [#()]].
	^ oldList, newList! !

SystemOrganizationEditor subclass: #SystemOrganizationUIModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!SystemOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/24/2008 22:17'!
categories

	self isShowingFullSystem ifTrue: [^ super categories].
	^ (self subjectCategories intersection: self changedCategories), addedCategories! !

!SystemOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 00:30'!
isShowingFullSystem
	^ system isShowingFullSystem! !

!SystemOrganizationUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 09:58'!
listAtCategoryNamed: catName

	| oldList newList category |
	category := catName asSymbol.
	(self categories includes: category) ifFalse: [^ #()].
	newList := (self changesInCategory: category) ifNil: [#()].
	oldList := self isShowingFullSystem ifFalse: [#()]
		ifTrue: [(self subjectListAtCategoryNamed: category) ifNil: [#()]].
	^ oldList, newList! !

MethodEditor subclass: #MethodEditorUIModel
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!MethodEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/24/2008 22:56'!
flagNew
	self propertyAt: #new put: true! !

!MethodEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/17/2008 10:56'!
flagRemoval
	self propertyAt: #removed put: true! !

!MethodEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/24/2008 22:57'!
isNew
	^ self propertyAt: #new ifAbsent: [false]! !

!MethodEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/17/2008 10:56'!
isRemoved
	^ self propertyAt: #removed ifAbsent: [false]! !

!MethodEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:26'!
propertyAt: key ifAbsentPut: aBlock

	^ self propertyAt: key ifAbsent: [
		self propertyAt: key put: aBlock value]! !

!MethodEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:26'!
propertyAt: key ifAbsent: aBlock

	^ properties
		ifNil: aBlock
		ifNotNil: [properties at: key ifAbsent: aBlock]! !

!MethodEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:27'!
propertyAt: aSymbol put: value

	properties ifNil: [properties := Dictionary new].
	^ properties at: aSymbol put: value! !

!MethodEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:26'!
propertyAt: key

	^self propertyAt: key ifAbsent: [nil]! !

ClassEditor subclass: #ClassEditorUIModel
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!ClassEditorUIModel class methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:36'!
on: aClass for: aSystemEditor
	| meta instance |
	meta := MetaclassEditorUIModel new.
	instance := meta new.
	instance setSubject: aClass system: aSystemEditor.
	^ instance! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:23'!
compile: source classified: cat withStamp: aString notifying: anObject logSource: aBoolean
	| cm |
	cm := MethodEditorUIModel
			source: source
			classified: cat
			stamp: aString
			notifying: anObject
			logging: aBoolean.
	self methods add: cm.
	^ cm selector! !

!ClassEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/25/2008 11:39'!
flagNew
	self propertyAt: #new put: true! !

!ClassEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/17/2008 11:08'!
flagRemoval
	self propertyAt: #removed put: true! !

!ClassEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/25/2008 11:40'!
isNew
	^ self propertyAt: #new ifAbsent: [false]! !

!ClassEditorUIModel methodsFor: 'flags' stamp: 'mtf 1/17/2008 11:08'!
isRemoved
	^ self propertyAt: #removed ifAbsent: [false]! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:38'!
methodDictionary
	| methodEditor |
	(methods isNil and: [self edRequiresRecompile not]) ifTrue: [^ subject methodDictionary].
	methodEditor := methods ifNil: [MethodDictionaryEditorUIModel for: self].
	^ methodEditor buildFor: self! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:39'!
methods
	^ methods ifNil: [methods := MethodDictionaryEditorUIModel for: self]! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/18/2008 14:44'!
organization
	^ organization ifNil: [organization := ClassOrganizationUIModel for: self]! !

!ClassEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:33'!
propertyAt: key ifAbsentPut: aBlock

	^ self propertyAt: key ifAbsent: [
		self propertyAt: key put: aBlock value]! !

!ClassEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:33'!
propertyAt: key ifAbsent: aBlock

	^ properties
		ifNil: aBlock
		ifNotNil: [properties at: key ifAbsent: aBlock]! !

!ClassEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:32'!
propertyAt: aSymbol put: value

	properties ifNil: [properties := Dictionary new].
	^ properties at: aSymbol put: value! !

!ClassEditorUIModel methodsFor: 'accessing properties' stamp: 'mtf 1/17/2008 09:32'!
propertyAt: key

	^self propertyAt: key ifAbsent: [nil]! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:39'!
setSubject: aClass system: aSystemEditor 
	subject := aClass.
	system := aSystemEditor. 
	subject ifNil: 
			[superEditor := aSystemEditor at: #Object.
			name := #Annonymous.
			type := #normal.
			instVarNames := Array new.
			classVarNames := Array new.
			sharedPools := Array new.
			methods := MethodDictionaryEditorUIModel for: self.
			self class edInitializeForNewClass].
	! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:05'!
subclass: aSymbol instanceVariableNames: instString classVariableNames: classString poolDictionaries: poolString category: categoryString 
	^ ((system 
		at: aSymbol
		ifAbsent: [ ClassEditorUIModel on: nil for: system])
			edName: aSymbol
			superclassEditor: self
			type: #normal
			instVarString: instString
			classVarString: classString
			poolImports: poolString
			category: categoryString) edRegisterEditor! !

!ClassEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:05'!
superclass: aClassOrEditor 
	superEditor := (aClassOrEditor isKindOf: ClassEditor) 
				ifTrue: [aClassOrEditor]
				ifFalse: [ (ClassEditor on: aClassOrEditor for: system) edRegisterEditor]! !

MethodDictionaryEditor subclass: #MethodDictionaryEditorUIModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SystemEditorBrowser'!

!MethodDictionaryEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 11:29'!
add: aModifiedMethod
	(self includesSelector: aModifiedMethod selector) ifFalse: [aModifiedMethod flagNew].
	^ super add: aModifiedMethod! !

!MethodDictionaryEditorUIModel methodsFor: 'UI closure' stamp: 'mtf 1/17/2008 09:25'!
at: aSymbol ifAbsent: absentBlock
	(removals includes: aSymbol) ifTrue: [^ absentBlock value].
	additions at: aSymbol ifPresent: [:editor | ^ editor].
	self subject at: aSymbol ifPresent: [:aCompiledMethod | ^ self add: (MethodEditorUIModel
		source: (classEditor subject sourceCodeAt: aSymbol)
		classified: (classEditor organization subject categoryOfElement: aSymbol)
		stamp: aCompiledMethod timeStamp
		notifying: nil
		logging: true )].
	^ absentBlock value! !

!MethodDictionaryEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/25/2008 11:51'!
remove: aSymbol
	| editor |
	editor := self at: aSymbol ifAbsent: [^ nil].
	additions at: (self uniqueNameLike: aSymbol) put: editor.
	additions removeKey: aSymbol.
	editor flagRemoval.
	^ editor! !

!MethodDictionaryEditorUIModel methodsFor: 'as yet unclassified' stamp: 'mtf 1/24/2008 22:49'!
uniqueNameLike: aSymbol
	"Answers a new, unique key under which to store a removed class editor. the key is an invalid class name, so It shouldn't caus spurious conflicts by still existing (it contains a period)"

	| try |
	self at: aSymbol ifAbsent: [^ aSymbol].

	1 to: 999999 do:
		[:i | try := (aSymbol , '.', i printString) asSymbol.
		self at: try ifAbsent: [^ try]]! !
